#import "DAIsySound.h"

@implementation DAIsySound
- (int)setDAIsyRecordingFormatForCD_DA      // :CD-DA,MD fs=44.1kHz
{
    return [super setDataSize:SND_DATA_SIZE       //Ͽ(30ʬ)
            dataFormat:SND_FORMAT_DSP_DATA_16     // Ͽեޥå
            samplingRate:SND_RATE_HIGH            // 44.1kHz
            channelCount:2                        // 2chƥ쥪
            infoSize:1];                          // ե
}

- (int)setDAIsyRecordingFormatForDAT        // :DAT fs=48kHz
{
    return [super setDataSize:SND_DATA_SIZE       //Ͽ(27ʬ)
            dataFormat:SND_FORMAT_DSP_DATA_16     // Ͽեޥå
            samplingRate:48000.0                  // 48kHz
            channelCount:2                        // 2chƥ쥪
            infoSize:1];                          // ե
}

- (int)setDAIsyRecordingFormatForBS         // :£ fs=32kHz
{
    return [super setDataSize:SND_DATA_SIZE       //Ͽ(42ʬ)
            dataFormat:SND_FORMAT_DSP_DATA_16     // Ͽեޥå
            samplingRate:32000.0                  // 32kHz
            channelCount:2                        // 2chƥ쥪
            infoSize:1];                          // ե
}

- convertTo16bitLinear      // DSP եޥåȤ Linear Ѵ
{
    SNDSoundStruct *sndStruct;		// ɹ¤

    if([self isDSPFormat] == YES)
    {
        sndStruct=[super soundStruct];	// ɹ¤ΤΥݥ󥿼
        sndStruct->dataFormat=SND_FORMAT_LINEAR_16;   // ̵񤭴
    } else return nil;

    return self;
}

- convertToDSPFormat        // Linear եޥåȤ DSP Ѵ
{
    SNDSoundStruct *sndStruct;		// ɹ¤

    if([self is16bitLinear] == YES)
    {
        sndStruct=[super soundStruct];	// ɹ¤ΤΥݥ󥿼
        sndStruct->dataFormat=SND_FORMAT_DSP_DATA_16; // ̵񤭴
    } else return nil;

    return self;
}

- (BOOL)isDSPFormat     // DSP եޥåȤɤ
{
    if([super dataFormat] == SND_FORMAT_DSP_DATA_16)
    {
        return YES;
    } else return NO;
}

- (BOOL)is16bitLinear;  // Linear եޥåȤɤ
{
    if([super dataFormat] == SND_FORMAT_LINEAR_16)
    {
        return YES;
    } else return NO;
}

- (BOOL)isCompressed;   // ̥եޥåȤɤ
{
    if([super dataFormat] == SND_FORMAT_COMPRESSED)
    {
        return YES;
    } else return NO;
}

/* convertToFormat:ϤΥ᥽åɤϡDSP_DAT򰷤ʤᡢ  */
/* DSPݡȤ饵ץ뤷ǡѴʤ              */
/* Υ᥽åɤ򥪡С饤ɤDSP_DATAȤ   */
/* ΥǡȤѴԤ褦ˤ                   */
/* ʤѤ˺ݤƤϡLINEAR_16DSP_DATȤѴ */
/* ʳϽʬ˥ƥȤƤʤΤդפ롣               */
- (int)convertToFormat:(int)newFormat    // եޥåѴʥС饤ɡ
{
    int snderr;

    if(newFormat == SND_FORMAT_DSP_DATA_16 && [self isDSPFormat] == YES)
        return SND_ERR_NONE;
    else if(newFormat == SND_FORMAT_DSP_DATA_16 && [self isDSPFormat] == NO)
    {
        if(snderr=[super convertToFormat:SND_FORMAT_LINEAR_16])
	    return snderr;
	if([self convertToDSPFormat]) return SND_ERR_NONE;
	else return SND_ERR_BAD_FORMAT;
    }
    else if([self isDSPFormat] == YES)
    {
        [self convertTo16bitLinear];
    }
    return [super convertToFormat:newFormat];
}

- (int)convertToFormat:(int)newFormat    // եޥåѴʥС饤ɡ
          samplingRate:(double)newRate
          channelCount:(int)newChannelCount
{
    int snderr;

    if(newFormat == SND_FORMAT_DSP_DATA_16 && [self isDSPFormat] == YES)
        return SND_ERR_NONE;
    else if(newFormat == SND_FORMAT_DSP_DATA_16 && [self isDSPFormat] == NO)
    {
        if(snderr=[super convertToFormat:SND_FORMAT_LINEAR_16
                            samplingRate:newRate
                            channelCount:newChannelCount])
	    return snderr;
	if([self convertToDSPFormat]) return SND_ERR_NONE;
	else return SND_ERR_BAD_FORMAT;
    }
    else if([self isDSPFormat] == YES)
    {
        [self convertTo16bitLinear];
    }
    return [super convertToFormat:newFormat
                     samplingRate:newRate
                     channelCount:newChannelCount];
}

@end
